
standard_mapper = {
        'current_mag' : ["CurrentsMagAng"],
        'current_angle' : ["CurrentsMagAng"],
        'current_real': ["Currents"],
        'current_imag': ["Currents"],
        'current_mag_rated': ["RatedCurrent", "NormalAmps", "normamps"],
        'current_mag_emgcy': ["EmergAmps"],
        'losses_real': ["Losses", 'PhaseLosses'],
        'losses_imag': ["Losses", 'PhaseLosses'],
        'sub_losses_real': ["SubstationLosses"],
        'sub_losses_imag': ["SubstationLosses"],
        'line_losses_real': ["LineLosses"],
        'line_losses_imag': ["LineLosses"],
        'power_real': ["Powers", 'TotalPower'],
        'power_imag': ["Powers", 'TotalPower'],
        'voltage_mag': ["puVmagAngle", "VoltagesMagAng"],
        'voltage_angle': ["puVmagAngle", "VoltagesMagAng"],
        'voltage_real': ["Voltages"],
        'voltage_imag': ["Voltages"],
        'voltage_mag_max_setpoint' : ['Vmaxpu'],
        'voltage_mag_min_setpoint' : ['Vminpu'],
        'frequency': ['Frequency'],
        'tap': ['Taps'],
        'soc': ['%stored'],
        'power_real_setpoint': ['kW'],
        'power_imagl_setpoint': ['kvar'],
        'voltage_setpoint': ['kV'],
        'power_mag_rated': ['kVARated'],
        'power_mag_base': ['kVABase'],
        'energy': ['kWh'],
}

unit_info = {
        'CurrentsMagAng' : {'E' : 'amp', 'O' : 'deg'},
        'Currents': {'E': 'amp', 'O': 'amp:'},
        'RatedCurrent': 'amp',
        'EmergAmps': 'amp',
        'NormalAmps': 'amp',
        'normamps': 'amp',
        'Losses': {'E' : 'kw', 'O' : 'kvar'},
        'PhaseLosses': {'E' : 'kw', 'O' : 'kvar'},
        'Powers':  {'E' : 'kw', 'O' : 'kvar'},
        'TotalPower':  {'E' : 'kw', 'O' : 'kvar'},
        'LineLosses':  {'E' : 'kw', 'O' : 'kvar'},
        'SubstationLosses':  {'E' : 'kw', 'O' : 'kvar'},
        'kV': 'kV',
        'kVARated': 'kvar',
        'kvar': 'kvar',
        'kW': 'kw',
        'kVABase': 'kva',
        'kWh': 'kwh',
        'puVmagAngle' : {'E' : 'pu', 'O' : 'deg'},
        'VoltagesMagAng': {'E' : 'v', 'O' : 'deg'},
        'VMagAngle': {'E' : 'v', 'O' : 'deg'},
        'Voltages': {'E': 'v', 'O': 'v'},
        'Vmaxpu': 'pu',
        'Vminpu': 'pu',
        'Frequency' : 'Hz',
        'Taps' : 'pu',
        '%stored' : 'SOC',
        'Distance' : 'mi'
    }

info_map = {
        'CurrentsMagAng' : {'E' : 'current_mag', 'O' : 'current_angle'},
        'Currents': {'E': 'current_real', 'O': 'current_imag'},
        'Losses': {'E' : 'losses_real', 'O' : 'losses_imag'},
        'PhaseLosses': {'E' : 'losses_real', 'O' : 'losses_imag'},
        'Powers':  {'E' : 'power_real', 'O' : 'power_imag'},
        'TotalPower':  {'E' : 'power_real', 'O' : 'power_imag'},
        'LineLosses':  {'E' : 'line_losses_real', 'O' : 'line_losses_imag'},
        'SubstationLosses':  {'E' : 'sub_losses_real', 'O' : 'sub_losses_imag'},
        'puVmagAngle' : {'E' : 'voltage_mag', 'O' : 'voltage_angle'},
        'VoltagesMagAng': {'E' : 'voltage_mag', 'O' : 'voltage_angle'},
        'VMagAngle': {'E' : 'voltage_mag', 'O' : 'voltage_angle'},
        'Voltages': {'E': 'voltage_real', 'O': 'voltage_imag'},
        'Vmaxpu': 'voltage_mag_max_setpoint',
        'Vminpu': 'voltage_mag_min_setpoint',
        'EmergAmps': 'current_mag_emgcy',
        'RatedCurrent': 'current_mag_rated',
        'NormalAmps': 'current_mag_rated',
        'normamps': 'current_mag_rated',
        'Frequency' : 'frequency',
        'Taps' : 'tap',
        '%stored' : 'soc',
        'Distance' : 'distance',
        'kV': 'voltage_setpoint',
        'kVARated': 'power_mag_rated',
        'kvar': 'power_imag_setpoint',
        'kW': 'power_real_setpoint',
        'kVABase': 'power_mag_base',
        'kWh': 'energy',
    }

type_info = {
        'CurrentsMagAng': 'vector',
        'Currents': 'vector',
        'RatedCurrent': 'double',
        'EmergAmps': 'double',
        'NormalAmps': 'double',
        'normamps': 'Amp',
        'Losses': 'vector',
        'PhaseLosses': 'vector',
        'Powers':  'vector',
        'TotalPower':  'vector',
        'LineLosses':  'vector',
        'SubstationLosses':  'vector',
        'kV': 'double',
        'kVARated': 'double',
        'kvar': 'double',
        'kW': 'double',
        'kVABase': 'double',
        'kWh': 'double',
        'puVmagAngle': 'vector',
        'VoltagesMagAng': 'vector',
        'VMagAngle': 'vector',
        'Voltages': 'vector',
        'Vmaxpu': 'double',
        'Vminpu': 'double',
        'Frequency': 'double',
        'Taps': 'vector',
        '%stored': 'double',
        'Distance': 'double'
    }
